module Diameter
  module Constants
    include AVPType
    include Vendors

    AVAILABLE_AVPS = { 'User-Name' => [1, UTF8String],
                       'User-Password' => [2, OctetString],
                       'CHAP-Password' => [3, OctetString],
                       'NAS-IP-Address' => [4, OctetString],
                       'NAS-Port' => [5, Unsigned32],
                       'Service-Type' => [6, Enumerated],
                       'Framed-Protocol' => [7, Enumerated],
                       'Framed-IP-Address' => [8, OctetString],
                       'Framed-IP-Netmask' => [9, IPAddress],
                       'Framed-Routing' => [10, Enumerated],
                       'Filter-Id' => [11, UTF8String],
                       'Framed-MTU' => [12, Unsigned32],
                       'Framed-Compression' => [13, Enumerated],
                       'Login-IP-Host' => [14, IPAddress],
                       'Login-Service' => [15, Enumerated],
                       'Login-TCP-Port' => [16, Unsigned32],
                       'Unassigned' => [17, OctetString],
                       'Reply-Message' => [18, UTF8String],
                       'Callback-Number' => [19, UTF8String],
                       'Callback-Id' => [20, UTF8String],
                       'Framed-Route' => [22, UTF8String],
                       'Framed-IPX-Network' => [23, UTF8String],
                       'State' => [24, OctetString],
                       'Class' => [25, OctetString],
                       'Vendor-Specific' => [26, Unsigned32],
                       'Session-Timeout' => [27, Unsigned32],
                       'Idle-Timeout' => [28, Unsigned32],
                       'Termination-Action' => [29, Unsigned32],
                       'Called-Station-Id' => [30, UTF8String],
                       'Calling-Station-Id' => [31, UTF8String],
                       'NAS-Identifier' => [32, OctetString],
                       'Proxy-State' => [33, OctetString],
                       'Login-LAT-Service' => [34, OctetString],
                       'Login-LAT-Node' => [35, OctetString],
                       'Login-LAT-Group' => [36, OctetString],
                       'Framed-AppleTalk-Link' => [37, Unsigned32],
                       'Framed-AppleTalk-Network' => [38, Unsigned32],
                       'Framed-AppleTalk-Zone' => [39, OctetString],
                       'Acct-Status-Type' => [40, Unsigned32],
                       'Acct-Delay-Time' => [41, Unsigned32],
                       'Acct-Input-Octets' => [42, Unsigned32],
                       'Acct-Output-Octets' => [43, Unsigned32],
                       'Acct-Session-Id' => [44, OctetString],
                       'Acct-Authentic' => [45, Enumerated],
                       'Acct-Session-Time' => [46, Unsigned32],
                       'Acct-Input-Packets' => [47, Integer32],
                       'Acct-Output-Packets' => [48, Integer32],
                       'Acct-Terminate-Cause' => [49, Unsigned32],
                       'Accounting-Multi-Session-Id' => [50, OctetString],
                       'Acct-Link-Count' => [51, Unsigned32],
                       'Acct-Input-Gigawords' => [52, Integer32],
                       'Acct-Output-Gigawords' => [53, Integer32],
                       'Event-Timestamp' => [55, Time],
                       'Egress-VLANID' => [56, OctetString],
                       'Ingress-Filters' => [57, Enumerated],
                       'Egress-VLAN-Name' => [58, UTF8String],
                       'User-Priority-Table' => [59, OctetString],
                       'CHAP-Challenge' => [60, OctetString],
                       'NAS-Port-Type' => [61, Enumerated],
                       'Port-Limit' => [62, Unsigned32],
                       'Login-LAT-Port' => [63, OctetString],
                       'Tunnel-Type' => [64, Enumerated],
                       'Tunnel-Medium-Type' => [65, Enumerated],
                       'Acct-Tunnel-Client-Endpoint' => [66, UTF8String],
                       'Tunnel-Server-Endpoint' => [67, UTF8String],
                       'Acct-Tunnel-Connection-ID' => [68, OctetString],
                       'Tunnel-Password' => [69, OctetString],
                       'ARAP-Password' => [70, OctetString],
                       'ARAP-Features' => [71, OctetString],
                       'ARAP-Zone-Access' => [72, Enumerated],
                       'ARAP-Security' => [73, Unsigned32],
                       'ARAP-Security-Data' => [74, OctetString],
                       'Password-Retry' => [75, Unsigned32],
                       'Prompt' => [76, Enumerated],
                       'Connect-Info' => [77, UTF8String],
                       'Configuration-Token' => [78, OctetString],
                       'EAP-Message' => [79, OctetString],
                       'Signature' => [80, OctetString],
                       'Tunnel-Private-Group-Id' => [81, OctetString],
                       'Tunnel-Assignment-Id' => [82, OctetString],
                       'Tunnel-Preference' => [83, Unsigned32],
                       'ARAP-Challenge-Response' => [84, OctetString],
                       'Acct-Interim-Interval' => [85, Unsigned32],
                       'Acct-Tunnel-Packets-Lost' => [86, Unsigned32],
                       'NAS-Port-Id' => [87, UTF8String],
                       'Framed-Pool' => [88, OctetString],
                       'CUI' => [89, UTF8String],
                       'Tunnel-Client-Auth-Id' => [90, UTF8String],
                       'Tunnel-Server-Auth-Id' => [91, UTF8String],
                       'NAS-Filter-Rule' => [92, UTF8String],
                       'Originating-Line-Info' => [94, OctetString],
                       'NAS-IPv6-Address' => [95, OctetString],
                       'Framed-Interface-Id' => [96, Unsigned64],
                       'Framed-IPv6-Prefix' => [97, OctetString],
                       'Login-IPv6-Host' => [98, OctetString],
                       'Framed-IPv6-Route' => [99, UTF8String],
                       'Framed-IPv6-Pool' => [100, OctetString],
                       'Error-Cause' => [101, Integer32],
                       'EAP-Key-Name' => [102, UTF8String],
                       'Digest-Response' => [103, UTF8String],
                       'Digest-Realm' => [104, UTF8String],
                       'Digest-Nonce' => [105, UTF8String],
                       'Digest-Response-Auth' => [106, UTF8String],
                       'Digest-Nextnonce' => [107, UTF8String],
                       'Digest-Method' => [108, UTF8String],
                       'Digest-URI' => [109, UTF8String],
                       'Digest-Qop' => [110, UTF8String],
                       'Digest-Algorithm' => [111, UTF8String],
                       'Digest-Entity-Body-Hash' => [112, UTF8String],
                       'Digest-Digest-CNonce' => [113, UTF8String],
                       'Digest-Nonce-Count' => [114, UTF8String],
                       'Digest-Username' => [115, UTF8String],
                       'Digest-Opaque' => [116, UTF8String],
                       'Digest-Auth-Param' => [117, UTF8String],
                       'Digest-AKA-Auts' => [118, UTF8String],
                       'Digest-Domain' => [119, UTF8String],
                       'Digest-Stale' => [120, UTF8String],
                       'Digest-HA1' => [121, UTF8String],
                       'SIP-AOR' => [122, UTF8String],
                       'Delegated-IPv6-Prefix' => [123, OctetString],
                       'MIP6-Feature-Vector' => [124, Unsigned64],
                       'MIP6-Home-Link-Prefix' => [125, OctetString],
                       'Operator-Name' => [126, OctetString],
                       'Location-Information' => [127, OctetString],
                       'Location-Data' => [128, OctetString],
                       'Basic-Location-Policy-Rules' => [129, OctetString],
                       'Extended-Location-Policy-Rules' => [130, OctetString],
                       'Location-Capable' => [131, OctetString],
                       'Requested-Location-Info' => [132, OctetString],
                       'Framed-Management-Protocol' => [133, Enumerated],
                       'Management-Transport-Protection' => [134, Enumerated],
                       'Management-Policy-Id' => [135, UTF8String],
                       'Management-Privilege-Level' => [136, Integer32],
                       'PKM-SS-Cert' => [137, OctetString],
                       'PKM-CA-Cert' => [138, OctetString],
                       'PKM-Config-Settings' => [139, OctetString],
                       'PKM-Cryptosuite-List' => [140, OctetString],
                       'PPKM-SAID' => [141, OctetString],
                       'PKM-SA-Descriptor' => [142, OctetString],
                       'PKM-Auth-Key' => [143, OctetString],
                       'Host-IP-Address' => [257, IPAddress],
                       'Auth-Application-Id' => [258, Unsigned32],
                       'Acct-Application-Id' => [259, Unsigned32],
                       'Vendor-Specific-Application-Id' => [260, Grouped],
                       'Redirect-Host-Usage' => [261, Enumerated],
                       'Redirect-Max-Cache-Time' => [262, Unsigned32],
                       'Session-Id' => [263, UTF8String],
                       'Origin-Host' => [264, DiameterIdentity],
                       'Supported-Vendor-Id' => [265, Unsigned32],
                       'Vendor-Id' => [266, Unsigned32],
                       'Firmware-Revision' => [267, Unsigned32],
                       'Result-Code' => [268, Unsigned32],
                       'Product-Name' => [269, UTF8String],
                       'Session-Binding' => [270, Unsigned32],
                       'Session-Server-Failover' => [271, Unsigned32],
                       'Multi-Round-Time-Out' => [272, Unsigned32],
                       'Disconnect-Cause' => [273, Enumerated],
                       'Auth-Request-Type' => [274, Unsigned32],
                       'Alternate-Peer' => [275, DiameterIdentity],
                       'Auth-Grace-Period' => [276, Unsigned32],
                       'Auth-Session-State' => [277, Unsigned32],
                       'Origin-State-Id' => [278, Unsigned32],
                       'Failed-AVP' => [279, Grouped],
                       'Proxy-Host' => [280, DiameterIdentity],
                       'Error-Message' => [281, UTF8String],
                       'Route-Record' => [282, DiameterIdentity],
                       'Destination-Realm' => [283, DiameterIdentity],
                       'Proxy-Info' => [284, Grouped],
                       'Re-Auth-Request-Type' => [285, Unsigned32],
                       'Accounting-Sub-Session-Id' => [287, Unsigned64],
                       'Unallocated' => [288, OctetString],
                       'Authorization-Lifetime' => [291, Integer32],
                       'Redirect-Host' => [292, DiameterURI],
                       'Destination-Host' => [293, DiameterIdentity],
                       'Error-Reporting-Host' => [294, DiameterIdentity],
                       'Termination-Cause' => [295, Enumerated],
                       'Origin-Realm' => [296, DiameterIdentity],
                       'Experimental-Result' => [297, Grouped],
                       'Experimental-Result-Code' => [298, Unsigned32],
                       'Inband-Security-Id' => [299, Unsigned32],
                       'E2E-Sequence' => [300, Grouped],
                       'Requested-Action' => [436, Enumerated],
                       'Accounting-Record-Type' => [480, Enumerated],
                       'Accounting-Realtime-Required' => [483, Unsigned32],
                       'Accounting-Record-Number' => [485, Unsigned32],
                       'TMOD-1' => [495, Grouped],
                       'Token-Rate' => [496, Float32],
                       'Bucket-Depth' => [497, Float32],
                       'Peak-Traffic-Rate' => [498, Float32],
                       'Minimum-Policed-Unit' => [499, Unsigned32],
                       'Maximum-Packet-Size' => [500, Unsigned32],
                       'TMOD-2' => [501, Grouped],
                       'Bandwidth' => [502, Float32],
                       'PHB-Class' => [503, Unsigned32],
                       'Port' => [530, Integer32],
                       'Port-Range' => [531, Grouped],
                       'Port-Start' => [532, Integer32],
                       'Port-End' => [533, Integer32],
                       '3GPP-CAMEL-Charging-Info' => [24, OctetString, TGPP],
                       'Authentication-Information-SIM' => [301, OctetString, TGPP],
                       'Authorization-Information-SIM' => [302, OctetString, TGPP],
                       '3GPP-AAA-Server-Name' => [318, OctetString, TGPP],
                       'Maximum-Number-Accesses' => [319, Unsigned32, TGPP],
                       'GBA-UserSecSettings' => [400, OctetString, TGPP],
                       'Transaction-Identifier' => [401, OctetString, TGPP],
                       'NAF-Hostname' => [402, OctetString, TGPP],
                       'GAA-Service-Identifier' => [403, OctetString, TGPP],
                       'Key-ExpiryTime' => [404, Time, TGPP],
                       'ME-Key-Material' => [405, OctetString, TGPP],
                       'UICC-Key-Material' => [406, OctetString, TGPP],
                       'GBA_U-Awareness-Indicator' => [407, Enumerated, TGPP],
                       'BootstrapInfoCreationTime' => [408, Time, TGPP],
                       'GUSS-Timestamp' => [409, Time, TGPP],
                       'GBA-Type' => [410, Enumerated, TGPP],
                       'UE-Id' => [411, OctetString, TGPP],
                       'UE-Id-Type' => [412, Enumerated, TGPP],
                       'UICC-App-Label' => [413, OctetString, TGPP],
                       'UICC-ME' => [414, Enumerated, TGPP],
                       'Requested-Key-Lifetime' => [415, Time, TGPP],
                       'Private-Identity-Request' => [416, Enumerated, TGPP],
                       'GBA-Push-Info' => [417, OctetString, TGPP],
                       'NAF-SA-Identifier' => [418, OctetString, TGPP],
                       'Security-Feature-Request' => [419, OctetString, TGPP],
                       'Security-Feature-Response' => [420, OctetString, TGPP],
                       'Event-Type' => [823, Grouped, TGPP],
                       'SIP-Method' => [824, UTF8String, TGPP],
                       'Event' => [825, UTF8String, TGPP],
                       'Content-Type' => [826, UTF8String, TGPP],
                       'Content-Length' => [827, Unsigned32, TGPP],
                       'Content-Disposition' => [828, UTF8String, TGPP],
                       'Role-Of-Node' => [829, Enumerated, TGPP],
                       'User-Session-Id' => [830, UTF8String, TGPP],
                       'Calling-Party-Address' => [831, UTF8String, TGPP],
                       'Called-Party-Address' => [832, UTF8String, TGPP],
                       'Time-Stamps' => [833, Grouped, TGPP],
                       'SIP-Request-Timestamp' => [834, Time, TGPP],
                       'SIP-Response-Timestamp' => [835, Time, TGPP],
                       'Application-Server' => [836, UTF8String, TGPP],
                       'Application-provided-Called-Party-Address' => [837, UTF8String, TGPP],
                       'Inter-Operator-Identifier' => [838, Grouped, TGPP],
                       'Originating-IOI' => [839, UTF8String, TGPP],
                       'Terminating-IOI' => [840, UTF8String, TGPP],
                       'IMS-Charging-Identifier' => [841, UTF8String, TGPP],
                       'SDP-Session-Description' => [842, UTF8String, TGPP],
                       'SDP-Media-components' => [843, Grouped, TGPP],
                       'SDP-Media-Name' => [844, UTF8String, TGPP],
                       'SDP-Media-Description' => [845, UTF8String, TGPP],
                       'CG-Address' => [846, IPAddress, TGPP],
                       'GGSN-Address' => [847, IPAddress, TGPP],
                       'Served-Party-IP-Address' => [848, IPAddress, TGPP],
                       'Authorised-QoS' => [849, UTF8String, TGPP],
                       'Application-Server-Information' => [850, Grouped, TGPP],
                       'Trunk-Group-ID' => [851, Grouped, TGPP],
                       'Incoming-Trunk-Group-ID' => [852, UTF8String, TGPP],
                       'Outgoing-Trunk-Group-ID' => [853, UTF8String, TGPP],
                       'Bearer-Service' => [854, OctetString, TGPP],
                       'Service-ID' => [855, UTF8String, TGPP],
                       'PoC-Controlling-Address' => [858, UTF8String, TGPP],
                       'PoC-Group-Name' => [859, UTF8String, TGPP],
                       'Cause' => [860, Grouped, TGPP],
                       'Cause-Code' => [861, Enumerated, TGPP],
                       'Node-Functionality' => [862, Unsigned32, TGPP],
                       'Service-Specific-Data' => [863, UTF8String, TGPP],
                       'Originator' => [864, Enumerated, TGPP],
                       'PS-Furnish-Charging-Information' => [865, Grouped, TGPP],
                       'PS-Free-Format-Data' => [866, OctetString, TGPP],
                       'PS-Append-Free-Format-Data' => [867, Enumerated, TGPP],
                       'Time-Quota-Threshold' => [868, Unsigned32, TGPP],
                       'Volume-Quota-Threshold' => [869, Unsigned32, TGPP],
                       'Trigger-Type' => [870, Enumerated, TGPP],
                       'Quota-Holding-Time' => [871, Unsigned32, TGPP],
                       'Reporting-Reason' => [872, Enumerated, TGPP],
                       'Service-Information' => [873, Grouped, TGPP],
                       'PS-Information' => [874, Grouped, TGPP],
                       'WLAN-Information' => [875, Grouped, TGPP],
                       'IMS-Information' => [876, Grouped, TGPP],
                       'MMS-Information' => [877, Grouped, TGPP],
                       'LCS-Information' => [878, Grouped, TGPP],
                       'PoC-Information' => [879, Grouped, TGPP],
                       'MBMS-Information' => [880, Grouped, TGPP],
                       'Quota-Consumption-Time' => [881, Unsigned32, TGPP],
                       'Media-Initiator-Flag' => [882, Enumerated, TGPP],
                       'PoC-Server-Role' => [883, Enumerated, TGPP],
                       'PoC-Session-Type' => [884, Enumerated, TGPP],
                       'Number-Of-Participants' => [885, Integer32, TGPP],
                       'Originator-Address' => [886, Grouped, TGPP],
                       'Participants-Involved' => [887, UTF8String, TGPP],
                       'Expires' => [888, Unsigned32, TGPP],
                       'Message-Body' => [889, Grouped, TGPP],
                       'WAG-Address' => [890, IPAddress, TGPP],
                       'WAG-PLMN-Id' => [891, OctetString, TGPP],
                       'WLAN-Radio-Container' => [892, Grouped, TGPP],
                       'WLAN-Technology' => [893, Unsigned32, TGPP],
                       'WLAN-UE-Local-IPAddress' => [894, IPAddress, TGPP],
                       'PDG-Address' => [895, IPAddress, TGPP],
                       'PDG-Charging-Id' => [896, Unsigned32, TGPP],
                       'Address-Data' => [897, UTF8String, TGPP],
                       'Address-Domain' => [898, Grouped, TGPP],
                       'Address-Type' => [899, Enumerated, TGPP],
                       'Bearer-Usage' => [1000, Enumerated, TGPP],
                       'Charging-Rule-Install' => [1001, Grouped, TGPP],
                       'Charging-Rule-Remove' => [1002, Grouped, TGPP],
                       'Charging-Rule-Definition' => [1003, Grouped, TGPP],
                       'Charging-Rule-Base-Name' => [1004, UTF8String, TGPP],
                       'Charging-Rule-Name' => [1005, OctetString, TGPP],
                       'Event-Trigger' => [1006, Enumerated, TGPP],
                       'Metering-Method' => [1007, Enumerated, TGPP],
                       'Offline' => [1008, Enumerated, TGPP],
                       'Online' => [1009, Enumerated, TGPP],
                       'Precedence' => [1010, Unsigned32, TGPP],
                       'Reporting-Level' => [1011, Enumerated, TGPP],
                       'TFT-Packet-Filter-Information' => [1013, Grouped, TGPP],
                       'ToS-Traffic-Class' => [1014, OctetString, TGPP],
                       'PDP-Session-operation' => [1015, Unsigned32, TGPP],
                       'QoS-Information' => [1016, Grouped, TGPP],
                       'Charging-Rule-Report' => [1018, Grouped, TGPP],
                       'PCC-Rule-Status' => [1019, Unsigned32, TGPP],
                       'Bearer-Identifier' => [1020, OctetString, TGPP],
                       'Bearer-Operation' => [1021, Enumerated, TGPP],
                       'Access-Network-Charging-Identifier-Gx' => [1022, Grouped, TGPP],
                       'Bearer-Control-Mode' => [1023, Enumerated, TGPP],
                       'Network-Request-Support' => [1024, Enumerated, TGPP],
                       'Guaranteed-Bitrate-DL' => [1025, Unsigned32, TGPP],
                       'Guaranteed-Bitrate-UL' => [1026, Unsigned32, TGPP],
                       'IP-CAN-Type' => [1027, Enumerated, TGPP],
                       'QoS-Class-Identifier' => [1028, Enumerated, TGPP],
                       'QoS-Negotiation' => [1029, Enumerated, TGPP],
                       'QoS-Upgrade' => [1030, Enumerated, TGPP],
                       'Rule-Failure-Code' => [1031, Enumerated, TGPP],
                       'RAT-Type' => [1032, Enumerated, TGPP],
                       'Event-Report-Indication' => [1033, Grouped, TGPP],
                       'Allocation-Retention-Priority' => [1034, Grouped, TGPP],
                       'CoA-IP-Address' => [1035, IPAddress, TGPP],
                       'Tunnel-Header-Length' => [1037, Unsigned32, TGPP],
                       'Tunnel-Information' => [1038, Grouped, TGPP],
                       'CoA-Information' => [1039, Grouped, TGPP],
                       'APN-Aggregate-Max-Bitrate-DL' => [1040, Unsigned32, TGPP],
                       'APN-Aggregate-Max-Bitrate-UL' => [1041, Unsigned32, TGPP],
                       'Revalidation-Time' => [1042, Time, TGPP],
                       'Rule-Activation-Time' => [1043, Time, TGPP],
                       'Rule-DeActivation-Time' => [1044, Time, TGPP],
                       'Session-Release-Cause' => [1045, Enumerated, TGPP],
                       'Priority-Level' => [1046, Unsigned32, TGPP],
                       'Pre-emption-Capability' => [1047, Enumerated, TGPP],
                       'Pre-emption-Vulnerability' => [1048, Enumerated, TGPP],
                       'Default-EPS-Bearer-QoS' => [1049, Grouped, TGPP],
                       'AN-GW-Address' => [1050, IPAddress, TGPP],
                       'QoS-Rule-Install' => [1051, Grouped, TGPP],
                       'QoS-Rule-Remove' => [1052, Grouped, TGPP],
                       'QoS-Rule-Definition' => [1053, Grouped, TGPP],
                       'QoS-Rule-Name' => [1054, OctetString, TGPP],
                       'QoS-Rule-Report' => [1055, Grouped, TGPP],
                       'Security-Parameter-Index' => [1056, OctetString, TGPP],
                       'Flow-Label' => [1057, OctetString, TGPP],
                       'Flow-Information' => [1058, Grouped, TGPP],
                       'Packet-Filter-Identifier' => [1060, OctetString, TGPP],
                       'Packet-Filter-Information' => [1061, Grouped, TGPP],
                       'Packet-Filter-Operation' => [1062, Enumerated, TGPP],
                       'Resource-Allocation-Notification' => [1063, Enumerated, TGPP],
                       'Session-Linking-Indicator' => [1064, Enumerated, TGPP],
                       'PDN-Connection-ID' => [1065, OctetString, TGPP],
                       'Monitoring-Key' => [1066, OctetString, TGPP],
                       'Usage-Monitoring-Information' => [1067, Grouped, TGPP],
                       'Usage-Monitoring-Level' => [1068, Enumerated, TGPP],
                       'Usage-Monitoring-Report' => [1069, Enumerated, TGPP],
                       'Usage-Monitoring-Support' => [1070, Enumerated, TGPP],
                       'CSG-Information-Reporting' => [1071, Enumerated, TGPP],
                       'Packet-Filter-Usage' => [1072, Enumerated, TGPP],
                       'Charging-Correlation-Indicator' => [1073, Enumerated, TGPP],
                       'QoS-Rule-Base-Name' => [1074, UTF8String, TGPP],
                       'Routing-Rule-Remove' => [1075, Grouped, TGPP],
                       'Routing-Rule-Definition' => [1076, Grouped, TGPP],
                       'Routing-Rule-Identifier' => [1077, OctetString, TGPP],
                       'Routing-Filter' => [1078, Grouped, TGPP],
                       'Routing-IP-Address' => [1079, IPAddress, TGPP],
                       'Flow-Direction' => [1080, Enumerated, TGPP],
                       'Routing-Rule-Install' => [1081, Grouped, TGPP],
                       'Maximum-Bandwidth' => [1082, Grouped, TGPP],
                       'Max-Supported-Bandwidth-DL' => [1083, Unsigned32, TGPP],
                       'Max-Supported-Bandwidth-UL' => [1084, Unsigned32, TGPP],
                       'Served-User-Identity' => [1100, Grouped, TGPP],
                       'VASP-ID' => [1101, UTF8String, TGPP],
                       'VAS-ID' => [1102, UTF8String, TGPP],
                       'Trigger-Event' => [1103, Enumerated, TGPP],
                       'Sender-Address' => [1104, UTF8String, TGPP],
                       'Initial-Recipient-Address' => [1105, Grouped, TGPP],
                       'Result-Recipient-Address' => [1106, Grouped, TGPP],
                       'MMS-Sequence-Number' => [1107, Unsigned32, TGPP],
                       'Recipient-Address' => [1108, UTF8String, TGPP],
                       'Routeing-Address' => [1109, UTF8String, TGPP],
                       'Originating-Interface' => [1110, Enumerated, TGPP],
                       'Delivery-Report' => [1111, Enumerated, TGPP],
                       'Read-Reply' => [1112, Enumerated, TGPP],
                       'Sender-Visibility' => [1113, Enumerated, TGPP],
                       'Service-Key' => [1114, UTF8String, TGPP],
                       'Billing-Information' => [1115, UTF8String, TGPP],
                       'Status' => [1116, Grouped, TGPP],
                       'Status-Code' => [1117, UTF8String, TGPP],
                       'Status-Text' => [1118, UTF8String, TGPP],
                       'Routeing-Address-Resolution' => [1119, Enumerated, TGPP],
                       'Domain-Name' => [1200, UTF8String, TGPP],
                       'Submission-Time' => [1202, Time, TGPP],
                       'MM-Content-Type' => [1203, Grouped, TGPP],
                       'Type-Number' => [1204, Enumerated, TGPP],
                       'Additional-Type-Information' => [1205, UTF8String, TGPP],
                       'Content-Size' => [1206, Unsigned32, TGPP],
                       'Additional-Content-Information' => [1207, Grouped, TGPP],
                       'Addressee-Type' => [1208, Enumerated, TGPP],
                       'Priority' => [1209, Enumerated, TGPP],
                       'Message-ID' => [1210, UTF8String, TGPP],
                       'Message-Type' => [1211, Enumerated, TGPP],
                       'Message-Size' => [1212, Unsigned32, TGPP],
                       'Message-Class' => [1213, Grouped, TGPP],
                       'Class-Identifier' => [1214, Enumerated, TGPP],
                       'Token-Text' => [1215, UTF8String, TGPP],
                       'Delivery-Report-Requested' => [1216, Enumerated, TGPP],
                       'Adaptations' => [1217, Enumerated, TGPP],
                       'Applic-ID' => [1218, UTF8String, TGPP],
                       'Aux-Applic-Info' => [1219, UTF8String, TGPP],
                       'Content-Class' => [1220, Enumerated, TGPP],
                       'DRM-Content' => [1221, Enumerated, TGPP],
                       'Read-Reply-Report-Requested' => [1222, Enumerated, TGPP],
                       'Reply-Applic-ID' => [1223, UTF8String, TGPP],
                       'File-Repair-Supported' => [1224, Enumerated, TGPP],
                       'MBMS-User-Service-Type' => [1225, Enumerated, TGPP],
                       'Unit-Quota-Threshold' => [1226, Unsigned32, TGPP],
                       'PDP-Address' => [1227, IPAddress, TGPP],
                       'SGSN-Address' => [1228, IPAddress, TGPP],
                       'PoC-Session-Id' => [1229, UTF8String, TGPP],
                       'Deferred-Location-Event-Type' => [1230, UTF8String, TGPP],
                       'LCS-APN' => [1231, UTF8String, TGPP],
                       'LCS-Client-ID' => [1232, Grouped, TGPP],
                       'LCS-Client-Dialed-By-MS' => [1233, UTF8String, TGPP],
                       'LCS-Client-External-ID' => [1234, UTF8String, TGPP],
                       'LCS-Client-Name' => [1235, Grouped, TGPP],
                       'LCS-Data-Coding-Scheme' => [1236, UTF8String, TGPP],
                       'LCS-Format-Indicator' => [1237, Enumerated, TGPP],
                       'LCS-Name-String' => [1238, UTF8String, TGPP],
                       'LCS-Requestor-ID' => [1239, Grouped, TGPP],
                       'LCS-Requestor-ID-String' => [1240, UTF8String, TGPP],
                       'LCS-Client-Type' => [1241, Enumerated, TGPP],
                       'Location-Estimate' => [1242, UTF8String, TGPP],
                       'Location-Estimate-Type' => [1243, Enumerated, TGPP],
                       'Location-Type' => [1244, Grouped, TGPP],
                       'Positioning-Data' => [1245, UTF8String, TGPP],
                       'WLAN-Session-Id' => [1246, UTF8String, TGPP],
                       'PDP-Context-Type' => [1247, Enumerated, TGPP],
                       'MMBox-Storage-Requested' => [1248, Enumerated, TGPP],
                       'Service-Specific-Info' => [1249, Grouped, TGPP],
                       'Called-Asserted-Identity' => [1250, UTF8String, TGPP],
                       'Requested-Party-Address' => [1251, UTF8String, TGPP],
                       'PoC-User-Role' => [1252, Grouped, TGPP],
                       'PoC-User-Role-IDs' => [1253, UTF8String, TGPP],
                       'PoC-User-Role-info-Units' => [1254, Enumerated, TGPP],
                       'Talk-Burst-Exchange' => [1255, Grouped, TGPP],
                       'Service-Generic-Information' => [1256, Grouped, TGPP],
                       'Service-Specific-Type' => [1257, Unsigned32, TGPP],
                       'Event-Charging-TimeStamp' => [1258, Time, TGPP],
                       'Participant-Access-Priority' => [1259, Enumerated, TGPP],
                       'Participant-Group' => [1260, Grouped, TGPP],
                       'PoC-Change-Condition' => [1261, Enumerated, TGPP],
                       'PoC-Change-Time' => [1262, Time, TGPP],
                       'Access-Network-Information' => [1263, UTF8String, TGPP],
                       'Trigger' => [1264, Grouped, TGPP],
                       'Base-Time-Interval' => [1265, Unsigned32, TGPP],
                       'Envelope' => [1266, Grouped, TGPP],
                       'Envelope-End-Time' => [1267, Time, TGPP],
                       'Envelope-Reporting' => [1268, Enumerated, TGPP],
                       'Envelope-Start-Time' => [1269, Time, TGPP],
                       'Time-Quota-Mechanism' => [1270, Grouped, TGPP],
                       'Time-Quota-Type' => [1271, Enumerated, TGPP],
                       'Early-Media-Description' => [1272, Grouped, TGPP],
                       'SDP-TimeStamps' => [1273, Grouped, TGPP],
                       'SDP-Offer-Timestamp' => [1274, Time, TGPP],
                       'SDP-Answer-Timestamp' => [1275, Time, TGPP],
                       'AF-Correlation-Information' => [1276, Grouped, TGPP],
                       'PoC-Session-Initiation-type' => [1277, Enumerated, TGPP],
                       'Offline-Charging' => [1278, Grouped, TGPP],
                       'User-Participating-Type' => [1279, Enumerated, TGPP],
                       'Alternate-Charged-Party-Address' => [1280, UTF8String, TGPP],
                       'IMS-Communication-Service-Identifier' => [1281, UTF8String, TGPP],
                       'Number-Of-Received-Talk-Bursts' => [1282, Unsigned32, TGPP],
                       'Number-Of-Talk-Bursts' => [1283, Unsigned32, TGPP],
                       'Received-Talk-Burst-Time' => [1284, Unsigned32, TGPP],
                       'Received-Talk-Burst-Volume' => [1285, Unsigned32, TGPP],
                       'Talk-Burst-Time' => [1286, Unsigned32, TGPP],
                       'Talk-Burst-Volume' => [1287, Unsigned32, TGPP],
                       'Media-Initiator-Party' => [1288, UTF8String, TGPP],
                       'Subscription-Data' => [1400, Grouped, TGPP],
                       'Terminal-Information' => [1401, Grouped, TGPP],
                       'IMEI' => [1402, UTF8String, TGPP],
                       'Software-Version' => [1403, UTF8String, TGPP],
                       'QoS-Subscribed' => [1404, OctetString, TGPP],
                       'ULR-Flags' => [1405, Unsigned32, TGPP],
                       'ULA-Flags' => [1406, Unsigned32, TGPP],
                       'Visited-PLMN-Id' => [1407, OctetString, TGPP],
                       'Requested-EUTRAN-Authentication-Info' => [1408, Grouped, TGPP],
                       'Requested-UTRAN-GERAN-Authentication-Info' => [1409, Grouped, TGPP],
                       'Number-Of-Requested-Vectors' => [1410, Unsigned32, TGPP],
                       'Re-Synchronization-Info' => [1411, OctetString, TGPP],
                       'Immediate-Response-Preferred' => [1412, Unsigned32, TGPP],
                       'Authentication-Info' => [1413, Grouped, TGPP],
                       'E-UTRAN-Vector' => [1414, Grouped, TGPP],
                       'UTRAN-Vector' => [1415, Grouped, TGPP],
                       'GERAN-Vector' => [1416, Grouped, TGPP],
                       'Network-Access-Mode' => [1417, Enumerated, TGPP],
                       'HPLMN-ODB' => [1418, Unsigned32, TGPP],
                       'Item-Number' => [1419, Unsigned32, TGPP],
                       'Cancellation-Type' => [1420, Enumerated, TGPP],
                       'DSR-Flags' => [1421, Unsigned32, TGPP],
                       'DSA-Flags' => [1422, Unsigned32, TGPP],
                       'Context-Identifier' => [1423, Unsigned32, TGPP],
                       'Subscriber-Status' => [1424, Enumerated, TGPP],
                       'Operator-Determined-Barring' => [1425, Unsigned32, TGPP],
                       'Access-Restriction-Data' => [1426, Unsigned32, TGPP],
                       'APN-OI-Replacement' => [1427, UTF8String, TGPP],
                       'All-APN-Configurations-Included-Indicator' => [1428, Enumerated, TGPP],
                       'APN-Configuration-Profile' => [1429, Grouped, TGPP],
                       'APN-Configuration' => [1430, Grouped, TGPP],
                       'EPS-Subscribed-QoS-Profile' => [1431, Grouped, TGPP],
                       'VPLMN-Dynamic-Address-Allowed' => [1432, Enumerated, TGPP],
                       'STN-SR' => [1433, OctetString, TGPP],
                       'Alert-Reason' => [1434, Enumerated, TGPP],
                       'AMBR' => [1435, Grouped, TGPP],
                       'CSG-Subscription-Data' => [1436, Grouped, TGPP],
                       'CSG-Id' => [1437, Unsigned32, TGPP],
                       'PDN-GW-Allocation-Type' => [1438, Enumerated, TGPP],
                       'Expiration-Date' => [1439, Time, TGPP],
                       'RAT-Frequency-Selection-Priority-ID' => [1440, Unsigned32, TGPP],
                       'IDA-Flags' => [1441, Unsigned32, TGPP],
                       'PUA-Flags' => [1442, Unsigned32, TGPP],
                       'NOR-Flags' => [1443, Unsigned32, TGPP],
                       'User-Id' => [1444, UTF8String, TGPP],
                       'Equipment-Status' => [1445, Enumerated, TGPP],
                       'Regional-Subscription-Zone-Code' => [1446, OctetString, TGPP],
                       'RAND' => [1447, OctetString, TGPP],
                       'XRES' => [1448, OctetString, TGPP],
                       'AUTN' => [1449, OctetString, TGPP],
                       'KASME' => [1450, OctetString, TGPP],
                       'Trace-Collection-Entity' => [1452, IPAddress, TGPP],
                       'Kc' => [1453, OctetString, TGPP],
                       'SRES' => [1454, OctetString, TGPP],
                       'Requesting-Node-Type' => [1455, Enumerated, TGPP],
                       'PDN-Type' => [1456, Enumerated, TGPP],
                       'Roaming-Restricted-Due-To-Unsupported-Feature' => [1457, Enumerated, TGPP],
                       'Trace-Data' => [1458, Grouped, TGPP],
                       'Trace-Reference' => [1459, OctetString, TGPP],
                       'Trace-Depth' => [1462, Enumerated, TGPP],
                       'Trace-NE-Type-List' => [1463, OctetString, TGPP],
                       'Trace-Interface-List' => [1464, OctetString, TGPP],
                       'Trace-Event-List' => [1465, OctetString, TGPP],
                       'OMC-Id' => [1466, OctetString, TGPP],
                       'GPRS-Subscription-Data' => [1467, Grouped, TGPP],
                       'Complete-Data-List-Included-Indicator' => [1468, Enumerated, TGPP],
                       'PDP-Context' => [1469, Grouped, TGPP],
                       'PDP-Type' => [1470, OctetString, TGPP],
                       'TGPP2-MEID' => [1471, OctetString, TGPP],
                       'Specific-APN-Info' => [1472, Grouped, TGPP],
                       'LCS-Info' => [1473, Grouped, TGPP],
                       'GMLC-Address' => [1474, OctetString, TGPP],
                       'LCS-PrivacyException' => [1475, Grouped, TGPP],
                       'SS-Code' => [1476, OctetString, TGPP],
                       'SS-Status' => [1477, OctetString, TGPP],
                       'Notification-To-UE-User' => [1478, Enumerated, TGPP],
                       'External-Client' => [1479, Grouped, TGPP],
                       'Client-Identity' => [1480, OctetString, TGPP],
                       'GMLC-Restriction' => [1481, Enumerated, TGPP],
                       'PLMN-Client' => [1482, Enumerated, TGPP],
                       'ServiceTypeIdentity' => [1484, Unsigned32, TGPP],
                       'MO-LR' => [1485, Grouped, TGPP],
                       'Teleservice-List' => [1486, Grouped, TGPP],
                       'TS-Code' => [1487, OctetString, TGPP],
                       'Call-Barring-Infor-List' => [1488, Grouped, TGPP],
                       'SGSN-Number' => [1489, OctetString, TGPP],
                       'IDR-Flags' => [1490, Unsigned32, TGPP],
                       'ICS-Indicator' => [1491, Enumerated, TGPP],
                       'IMS-Voice-Over-PS-Sessions-Supported' => [1492, Enumerated, TGPP],
                       'Homogeneous-Support-of-IMS-Voice-Over-PS-Sessions' =>   [1493, Enumerated, TGPP],
                       'Last-UE-Activity-Time' => [1494, Time, TGPP],
                       'EPS-User-State' => [1495, Grouped, TGPP],
                       'EPS-Location-Information' => [1496, Grouped, TGPP],
                       'MME-User-State' => [1497, Grouped, TGPP],
                       'SGSN-User-State' => [1498, Grouped, TGPP],
                       'User-State' => [1499, Enumerated, TGPP],
                       'Non-3GPP-User-Data' => [1500, Grouped, TGPP],
                       'Non-3GPP-IP-Access' => [1501, Enumerated, TGPP],
                       'Non-3GPP-IP-Access-APN' => [1502, Enumerated, TGPP],
                       'AN-Trusted' => [1503, Enumerated, TGPP],
                       'ANID' => [1504, UTF8String, TGPP],
                       'Trace-Info' => [1505, Grouped, TGPP],
                       'MIP-FA-RK' => [1506, OctetString, TGPP],
                       'MIP-FA-RK-SPI' => [1507, Unsigned32, TGPP],
                       'MME-Location-Information' => [1600, Grouped, TGPP],
                       'SGSN-Location-Information' => [1601, Grouped, TGPP],
                       'E-UTRAN-Cell-Global-Identity' => [1602, OctetString, TGPP],
                       'Tracking-Area-Identity' => [1603, OctetString, TGPP],
                       'Cell-Global-Identity' => [1604, OctetString, TGPP],
                       'Routing-Area-Identity' => [1605, OctetString, TGPP],
                       'Location-Area-Identity' => [1606, OctetString, TGPP],
                       'Service-Area-Identity' => [1607, OctetString, TGPP],
                       'Geographical-Information' => [1608, OctetString, TGPP],
                       'Geodetic-Information' => [1609, OctetString, TGPP],
                       'Current-Location-Retrieved' => [1610, Enumerated, TGPP],
                       'Age-Of-Location-Information' => [1611, Unsigned32, TGPP],
                       'Active-APN' => [1612, Grouped, TGPP],
                       'SIPTO-Permission' => [1613, Enumerated, TGPP],
                       'Error-Diagnostic' => [1614, Enumerated, TGPP],
                       'UE-SRVCC-Capability' => [1615, Enumerated, TGPP],
                       'MPS-Priority' => [1616, Unsigned32, TGPP],
                       'VPLMN-LIPA-Allowed' => [1617, Enumerated, TGPP],
                       'LIPA-Permission' => [1618, Enumerated, TGPP],
                       'Subscribed-Periodic-RAU-TAU-Timer' => [1619, Unsigned32, TGPP],
                       'Ext-PDP-Type' => [1620, OctetString, TGPP],
                       'Ext-PDP-Address' => [1621, IPAddress, TGPP],
                       'MDT-Configuration' => [1622, Grouped, TGPP],
                       'Job-Type' => [1623, Enumerated, TGPP],
                       'Area-Scope' => [1624, Grouped, TGPP],
                       'List-Of-Measurements' => [1625, Unsigned32, TGPP],
                       'Reporting-Trigger' => [1626, Unsigned32, TGPP],
                       'Report-Interval' => [1627, Enumerated, TGPP],
                       'Report-Amount' => [1628, Enumerated, TGPP],
                       'Event-Threshold-RSRP' => [1629, Unsigned32, TGPP],
                       'Event-Threshold-RSRQ' => [1630, Unsigned32, TGPP],
                       'Logging-Interval' => [1631, Enumerated, TGPP],
                       'Logging-Duration' => [1632, Enumerated, TGPP],
                       'Relay-Node-Indicator' => [1633, Enumerated, TGPP],
                       'MDT-User-Consent' => [1634, Enumerated, TGPP],
                       'PUR-Flags' => [1635, Unsigned32, TGPP],
                       'Subscribed-VSRVCC' => [1636, Enumerated, TGPP],
                       'Equivalent-PLMN-List' => [1637, Grouped, TGPP],
                       'CLR-Flags' => [1638, Unsigned32, TGPP],
                       'UVR-Flags' => [1639, Unsigned32, TGPP],
                       'UVA-Flags' => [1640, Unsigned32, TGPP],
                       'VPLMN-CSG-Subscription-Data' => [1641, Grouped, TGPP],
                       'Time-Zone' => [1642, UTF8String, TGPP],
                       'A-MSISDN' => [1643, OctetString, TGPP],
                       'MME-Number-for-MT-SMS' => [1645, OctetString, TGPP],
                       'SMS-Register-Request' => [1648, Enumerated, TGPP],
                       'Daylight-Saving-Time' => [1650, Enumerated, TGPP],
                       'Subscription-Data-Flags' => [1654, Unsigned32, TGPP],
                       'Measurement-Period-UMTS' => [1655, Enumerated, TGPP],
                       'Measurement-Period-LTE' => [1656, Enumerated, TGPP],
                       'Collection-Period-RRM-LTE' => [1657, Enumerated, TGPP],
                       'Collection-Period-RRM-UMTS' => [1658, Enumerated, TGPP],
                       'Positioning-Method' => [1659, OctetString, TGPP],
                       'Measurement-Quantity' => [1660, OctetString, TGPP],
                       'Event-Threshold-Event-1F' => [1661, Integer32, TGPP],
                       'Event-Threshold-Event-1I' => [1662, Integer32, TGPP],
                       'Restoration-Priority' => [1663, Unsigned32, TGPP],
                       'SMS-Information' => [2000, Grouped, TGPP],
                       'Data-Coding-Scheme' => [2001, Integer32, TGPP],
                       'Destination-Interface' => [2002, Grouped, TGPP],
                       'Interface-Id' => [2003, UTF8String, TGPP],
                       'Interface-Port' => [2004, UTF8String, TGPP],
                       'Interface-Text' => [2005, UTF8String, TGPP],
                       'Interface-Type' => [2006, Enumerated, TGPP],
                       'SM-Message-Type' => [2007, Enumerated, TGPP],
                       'Originating-SCCP-Address' => [2008, IPAddress, TGPP],
                       'Originator-Interface' => [2009, Grouped, TGPP],
                       'Recipient-SCCP-Address' => [2010, IPAddress, TGPP],
                       'Reply-Path-Requested' => [2011, Enumerated, TGPP],
                       'SM-Discharge-Time' => [2012, Time, TGPP],
                       'SM-Protocol-ID' => [2013, OctetString, TGPP],
                       'SM-Status' => [2014, OctetString, TGPP],
                       'SM-User-Data-Header' => [2015, OctetString, TGPP],
                       'SMS-Node' => [2016, Enumerated, TGPP],
                       'SMSC-Address' => [2017, IPAddress, TGPP],
                       'Client-Address' => [2018, IPAddress, TGPP],
                       'Number-of-Messages-Sent' => [2019, Unsigned32, TGPP],
                       'Low-Balance-Indication' => [2020, Enumerated, TGPP],
                       'Remaining-Balance' => [2021, Grouped, TGPP],
                       'Refund-Information' => [2022, OctetString, TGPP],
                       'Carrier-Select-Routing-Information' => [2023, UTF8String, TGPP],
                       'Number-Portability-Routing-Information' => [2024, UTF8String, TGPP],
                       'PoC-Event-Type' => [2025, Enumerated, TGPP],
                       'Recipients' => [2026, Grouped, TGPP],
                       'Recipient-Received-Address' => [2028, Grouped, TGPP],
                       'SM-Service-Type' => [2029, Enumerated, TGPP],
                       'MMTel-Information' => [2030, Grouped, TGPP],
                       'Service-type' => [2031, Enumerated, TGPP],
                       'Service-Mode' => [2032, Enumerated, TGPP],
                       'Subscriber-Role' => [2033, Enumerated, TGPP],
                       'Number-Of-Diversions' => [2034, Unsigned32, TGPP],
                       'Associated-Party-Address' => [2035, UTF8String, TGPP],
                       'SDP-Type' => [2036, Enumerated, TGPP],
                       'Change-Condition' => [2037, Integer32, TGPP],
                       'Change-Time' => [2038, Time, TGPP],
                       'Diagnostics' => [2039, Enumerated, TGPP],
                       'Service-Data-Container' => [2040, Grouped, TGPP],
                       'Start-Time' => [2041, Time, TGPP],
                       'Stop-Time' => [2042, Time, TGPP],
                       'Time-First-Usage' => [2043, Time, TGPP],
                       'Time-Last-Usage' => [2044, Time, TGPP],
                       'Time-Usage' => [2045, Unsigned32, TGPP],
                       'Traffic-Data-Volumes' => [2046, Grouped, TGPP],
                       'Serving-Node-Type' => [2047, Enumerated, TGPP],
                       'Supplementary-Service' => [2048, Grouped, TGPP],
                       'Participant-Action-Type' => [2049, Enumerated, TGPP],
                       'Dynamic-Address-Flag' => [2051, Enumerated, TGPP],
                       'Accumulated-Cost' => [2052, Grouped, TGPP],
                       'AoC-Cost-Information' => [2053, Grouped, TGPP],
                       'AoC-Information' => [2054, Grouped, TGPP],
                       'AoC-Request-Type' => [2055, Enumerated, TGPP],
                       'Current-Tariff' => [2056, Grouped, TGPP],
                       'Next-Tariff' => [2057, Grouped, TGPP],
                       'Rate-Element' => [2058, Grouped, TGPP],
                       'Scale-Factor' => [2059, Grouped, TGPP],
                       'Tariff-Information' => [2060, Grouped, TGPP],
                       'Unit-Cost' => [2061, Grouped, TGPP],
                       'Incremental-Cost' => [2062, Grouped, TGPP],
                       'Local-Sequence-Number' => [2063, Unsigned32, TGPP],
                       'Node-Id' => [2064, UTF8String, TGPP],
                       'SGW-Change' => [2065, Enumerated, TGPP],
                       'Charging-Characteristics-Selection-Mode' => [2066, Enumerated, TGPP],
                       'SGW-Address' => [2067, IPAddress, TGPP],
                       'Dynamic-Address-Flag-Extension' => [2068, Enumerated, TGPP],
                       'Application-Server-ID' => [2101, Unsigned32, TGPP],
                       'Application-Service-Type' => [2102, Enumerated, TGPP],
                       'Application-Session-ID' => [2103, Unsigned32, TGPP],
                       'Delivery-Status' => [2104, UTF8String, TGPP],
                       'IM-Information' => [2110, Grouped, TGPP],
                       'Number-Of-Messages-Successfully-Exploded' => [2111, Unsigned32, TGPP],
                       'Number-Of-Messages-Successfully-Sent' => [2112, Unsigned32, TGPP],
                       'Total-Number-Of-Messages-Exploded' => [2113, Unsigned32, TGPP],
                       'Total-Number-Of-Messages-Sent' => [2114, Unsigned32, TGPP],
                       'DCD-Information' => [2115, Grouped, TGPP],
                       'Content-ID' => [2116, UTF8String, TGPP],
                       'Content-provider-ID' => [2117, UTF8String, TGPP],
                       'Charge-Reason-Code' => [2118, Enumerated, TGPP],
                       'SIP-Request-Timestamp-Fraction' => [2301, Unsigned32, TGPP],
                       'SIP-Response-Timestamp-Fraction' => [2302, Unsigned32, TGPP],
                       'Online-Charging-Flag' => [2303, Enumerated, TGPP],
                       'CUG-Information' => [2304, OctetString, TGPP],
                       'Real-Time-Tariff-Information' => [2305, Grouped, TGPP],
                       'Tariff-XML' => [2306, UTF8String, TGPP],
                       'MBMS-GW-Address' => [2307, IPAddress, TGPP],
                       'IMSI-Unauthenticated-Flag' => [2308, Enumerated, TGPP],
                       'Account-Expiration' => [2309, Time, TGPP],
                       'AoC-Format' => [2310, Enumerated, TGPP],
                       'AoC-Service' => [2311, Grouped, TGPP],
                       'AoC-Service-Obligatory-Type' => [2312, Enumerated, TGPP],
                       'AoC-Service-Type' => [2313, Enumerated, TGPP],
                       'AoC-Subscription-Information' => [2314, Grouped, TGPP],
                       'Preferred-AoC-Currency' => [2315, Unsigned32, TGPP],
                       'CSG-Access-Mode' => [2317, Enumerated, TGPP],
                       'CSG-Membership-Indication' => [2318, Enumerated, TGPP],
                       'User-CSG-Information' => [2319, Grouped, TGPP],
                       'Outgoing-Session-Id' => [2320, UTF8String, TGPP],
                       'Initial-IMS-Charging-Identifier' => [2321, UTF8String, TGPP],
                       'LMSI' => [2400, OctetString, TGPP],
                       'Serving-Node' => [2401, Grouped, TGPP],
                       'MME-Name' => [2402, DiameterIdentity, TGPP],
                       'MSC-Number' => [2403, OctetString, TGPP],
                       'LCS-Capabilities-Sets' => [2404, Unsigned32, TGPP],
                       'Additional-Serving-Node' => [2406, Grouped, TGPP],
                       'PSR-Address' => [2407, IPAddress, TGPP],
                       'MME-Realm' => [2408, DiameterIdentity, TGPP],
                       'SGSN-Name' => [2409, DiameterIdentity, TGPP],
                       'SGSN-Realm' => [2410, DiameterIdentity, TGPP],
                       'RIA-Flags' => [2411, Unsigned32, TGPP],
                       'LCS-EPS-Client-Name' => [2501, Grouped, TGPP],
                       'LCS-Requestor-Name' => [2502, Grouped, TGPP],
                       'LCS-Priority' => [2503, Unsigned32, TGPP],
                       'LCS-QoS' => [2504, Grouped, TGPP],
                       'Horizontal-Accuracy' => [2505, Unsigned32, TGPP],
                       'Vertical-Accuracy' => [2506, Unsigned32, TGPP],
                       'Velocity-Requested' => [2508, Enumerated, TGPP],
                       'Response-Time' => [2509, Enumerated, TGPP],
                       'Supported-GAD-Shapes' => [2510, Unsigned32, TGPP],
                       'LCS-Codeword' => [2511, UTF8String, TGPP],
                       'LCS-Privacy-Check' => [2512, Enumerated, TGPP],
                       'Accuracy-Fulfilment-Indicator' => [2513, Enumerated, TGPP],
                       'Age-Of-Location-Estimate' => [2514, Unsigned32, TGPP],
                       'Velocity-Estimate' => [2515, OctetString, TGPP],
                       'EUTRAN-Positioning-Data' => [2516, OctetString, TGPP],
                       'ECGI' => [2517, OctetString, TGPP],
                       'Location-Event' => [2518, Enumerated, TGPP],
                       'LCS-Service-Type-ID' => [2520, Unsigned32, TGPP],
                       'LCS-Privacy-Check-Non-Session' => [2521, Grouped, TGPP],
                       'LCS-Privacy-Check-Session' => [2522, Grouped, TGPP],
                       'LCS-QoS-Class' => [2523, Enumerated, TGPP],
                       'IMS-Application-Reference-Identifier' => [2601, UTF8String, TGPP],
                       'Low-Priority-Indicator' => [2602, Enumerated, TGPP],
                       'IP-Realm-Default-Indicator' => [2603, Enumerated, TGPP],
                       'Local-GW-Inserted-Indicator' => [2604, Enumerated, TGPP],
                       'Transcoder-Inserted-Indicator' => [2605, Enumerated, TGPP],
                       'PDP-Address-Prefix-Length' => [2606, Unsigned32, TGPP],
                       'Presence-Reporting-Area-Elements-List' => [2820, OctetString, TGPP],
                       'Presence-Reporting-Area-Identifier' => [2821, OctetString, TGPP],
                       'Presence-Reporting-Area-Information' => [2822, Grouped, TGPP],
                       'Presence-Reporting-Area-Status' => [2823, Enumerated, TGPP],
                       'Policy-Counter-Identifier' => [2901, UTF8String, TGPP],
                       'Policy-Counter-Status' => [2902, UTF8String, TGPP],
                       'Policy-Counter-Status-Report' => [2903, Grouped, TGPP],
                       'SL-Request-Type' => [2904, Enumerated, TGPP],
                       'Pending-Policy-Counter-Information' => [2905, Grouped, TGPP],
                       'Pending-Policy-Counter-Change-Time' => [2906, Time, TGPP],
                       'Device-Action' => [3001, Grouped, TGPP],
                       'Device-Notification' => [3002, Grouped, TGPP],
                       'Trigger-Data' => [3003, Grouped, TGPP],
                       'Payload' => [3004, OctetString, TGPP],
                       'Action-Type' => [3005, Enumerated, TGPP],
                       'Priority-Indication' => [3006, Enumerated, TGPP],
                       'Reference-Number' => [3007, Unsigned32, TGPP],
                       'Request-Status' => [3008, Enumerated, TGPP],
                       'Delivery-Outcome' => [3009, Enumerated, TGPP],
                       'Application-Port-Identifier' => [3010, Unsigned32, TGPP],
                       'IP-SM-GW-Number' => [3100, OctetString, TGPP],
                       'IP-SM-GW-Name' => [3101, DiameterIdentity, TGPP],
                       'User-Identifier' => [3102, Grouped, TGPP],
                       'SCS-Identity' => [3104, OctetString, TGPP],
                       'Service-Parameters' => [3105, Grouped, TGPP],
                       'T4-Parameters' => [3106, Grouped, TGPP],
                       'Service-Data' => [3107, Grouped, TGPP],
                       'T4-Data' => [3108, Grouped, TGPP],
                       'HSS-Cause' => [3109, Unsigned32, TGPP],
                       'SIR-Flags' => [3110, Unsigned32, TGPP],
                       'External-Identifier' => [3111, UTF8String, TGPP],
                       'SM-Delivery-Outcome-T4' => [3200, Enumerated, TGPP],
                       'Absent-Subscriber-Diagnostic-T4' => [3201, Enumerated, TGPP],
                       '3GPP-IMSI' => [1, UTF8String, TGPP],
                       '3GPP-Charging-Id' => [2, OctetString, TGPP],
                       '3GPP-PDP-Type' => [3, Enumerated, TGPP],
                       '3GPP-CG-Address' => [4, IPAddress, TGPP],
                       '3GPP-GPRS-Negotiated-QoS-profile' => [5, UTF8String, TGPP],
                       '3GPP-SGSN-Address' => [6, IPAddress, TGPP],
                       '3GPP-GGSN-Address' => [7, IPAddress, TGPP],
                       '3GPP-IMSI-MCC-MNC' => [8, UTF8String, TGPP],
                       '3GPP-GGSN-MCC-MNC' => [9, UTF8String, TGPP],
                       '3GPP-NSAPI' => [10, UTF8String, TGPP],
                       '3GPP-Session-Stop-Indicator' => [11, UTF8String, TGPP],
                       '3GPP-Selection-Mode' => [12, UTF8String, TGPP],
                       '3GPP-Charging-Characteristics' => [13, UTF8String, TGPP],
                       '3GPP-CG-IPv6-Address' => [14, OctetString, TGPP],
                       '3GPP-SGSN-IPv6-Address' => [15, OctetString, TGPP],
                       '3GPP-GGSN-IPv6-Address' => [16, OctetString, TGPP],
                       '3GPP-IPv6-DNS-Server' => [17, OctetString, TGPP],
                       '3GPP-SGSN-MCC-MNC' => [18, UTF8String, TGPP],
                       '3GPP-Teardown-Indicator' => [19, OctetString, TGPP],
                       '3GPP-IMEISV' => [20, OctetString, TGPP],
                       '3GPP-RAT-Type' => [21, OctetString, TGPP],
                       '3GPP-User-Location-Info' => [22, OctetString, TGPP],
                       '3GPP-MS-TimeZone' => [23, OctetString, TGPP],
                       'Authentication-Method' => [300, Enumerated, TGPP],
                       '3GPP-Packet-Filter' => [25, OctetString, TGPP],
                       '3GPP-Negotiated-DSCP' => [26, OctetString, TGPP],
                       '3GPP-Allocate-IP-Type' => [27, OctetString, TGPP],
                       'Abort-Cause' => [500, Enumerated, TGPP],
                       'Access-Network-Charging-Address' => [501, IPAddress, TGPP],
                       'Access-Network-Charging-Identifier' => [502, Grouped, TGPP],
                       'Access-Network-Charging-Identifier-Value' => [503, OctetString, TGPP],
                       'AF-Application-Identifier' => [504, OctetString, TGPP],
                       'AF-Charging-Identifier' => [505, OctetString, TGPP],
                       'Authorization-Token' => [506, OctetString, TGPP],
                       'Flow-Grouping' => [508, Grouped, TGPP],
                       'Flow-Number' => [509, Unsigned32, TGPP],
                       'Flows' => [510, Grouped, TGPP],
                       'Flow-Status' => [511, Enumerated, TGPP],
                       'Flow-Usage' => [512, Enumerated, TGPP],
                       'Specific-Action' => [513, Enumerated, TGPP],
                       'Max-Requested-Bandwidth-DL' => [515, Unsigned32, TGPP],
                       'Max-Requested-Bandwidth-UL' => [516, Unsigned32, TGPP],
                       'Media-Component-Description' => [517, Grouped, TGPP],
                       'Media-Component-Number' => [518, Unsigned32, TGPP],
                       'Media-Sub-Component' => [519, Grouped, TGPP],
                       'Media-Type' => [520, Enumerated, TGPP],
                       'RR-Bandwidth' => [521, Unsigned32, TGPP],
                       'RS-Bandwidth' => [522, Unsigned32, TGPP],
                       'SIP-Forking-Indication' => [523, Enumerated, TGPP],
                       'Codec-Data AVP' => [524, UTF8String, TGPP],
                       'Service-URN' => [525, OctetString, TGPP],
                       'Acceptable-Service-Info' => [526, Grouped, TGPP],
                       'Service-Info-Status' => [527, Enumerated, TGPP],
                       'MPS-Identifier' => [528, OctetString, TGPP],
                       'AF-Signalling-Protocol' => [529, Enumerated, TGPP],
                       'Sponsor-Identity' => [531, OctetString, TGPP],
                       'Application-Service-Provider-Identity' => [532, OctetString, TGPP],
                       'Rx-Request-Type' => [533, Enumerated, TGPP],
                       'Min-Requested-Bandwidth-DL' => [534, Unsigned32, TGPP],
                       'Min-Requested-Bandwidth-UL' => [535, Unsigned32, TGPP],
                       'Required-Access-Info' => [536, Enumerated, TGPP],
                       'IP-Domain-Id' => [537, OctetString, TGPP],
                       'Visited-Network-Identifier' => [600, OctetString, TGPP],
                       'Public-Identity' => [601, UTF8String, TGPP],
                       'Server-Name' => [602, UTF8String, TGPP],
                       'Server-Capabilities' => [603, Grouped, TGPP],
                       'Mandatory-Capability' => [604, Unsigned32, TGPP],
                       'Optional-Capability' => [605, Unsigned32, TGPP],
                       'User-Data' => [606, OctetString, TGPP],
                       'SIP-Number-Auth-Items' => [607, Unsigned32, TGPP],
                       'SIP-Authentication-Scheme' => [608, UTF8String, TGPP],
                       'SIP-Authenticate' => [609, OctetString, TGPP],
                       'SIP-Authorization' => [610, OctetString, TGPP],
                       'SIP-Authentication-Context' => [611, OctetString, TGPP],
                       'SIP-Auth-Data-Item' => [612, Grouped, TGPP],
                       'SIP-Item-Number' => [613, Unsigned32, TGPP],
                       'Server-Assignment-Type' => [614, Enumerated, TGPP],
                       'Deregistration-Reason' => [615, Grouped, TGPP],
                       'Reason-Code' => [616, Enumerated, TGPP],
                       'Reason-Info' => [617, UTF8String, TGPP],
                       'Charging-Information' => [618, Grouped, TGPP],
                       'Primary-Event-Charging-Function-Name' => [619, DiameterURI, TGPP],
                       'Secondary-Event-Charging-Function-Name' => [620, DiameterURI, TGPP],
                       'Primary-Charging-Collection-Function-Name' => [621, DiameterURI, TGPP],
                       'Secondary-Charging-Collection-Function-Name' => [622, DiameterURI, TGPP],
                       'User-Authorization-Type' => [623, Enumerated, TGPP],
                       'User-Data-Already-Available' => [624, Enumerated, TGPP],
                       'Confidentiality-Key' => [625, OctetString, TGPP],
                       'Integrity-Key' => [626, OctetString, TGPP],
                       'Supported-Features' => [628, Grouped, TGPP],
                       'Feature-List-ID' => [629, Unsigned32, TGPP],
                       'Feature-List' => [630, Unsigned32, TGPP],
                       'Supported-Applications' => [631, Grouped, TGPP],
                       'Associated-Identities' => [632, Grouped, TGPP],
                       'Originating-Request' => [633, Enumerated, TGPP],
                       'Wildcarded-PSI' => [634, UTF8String, TGPP],
                       'SIP-Digest-Authenticate AVP' => [635, Grouped, TGPP],
                       'Wildcarded-IMPU' => [636, UTF8String, TGPP],
                       'UAR-Flags' => [637, Unsigned32, TGPP],
                       'Loose-Route-Indication' => [638, Enumerated, TGPP],
                       'SCSCF-Restoration-Info' => [639, Grouped, TGPP],
                       'Path' => [640, OctetString, TGPP],
                       'Contact' => [641, OctetString, TGPP],
                       'Subscription-Info' => [642, Grouped, TGPP],
                       'Call-ID-SIP-Header' => [643, OctetString, TGPP],
                       'From-SIP-Header' => [644, OctetString, TGPP],
                       'To-SIP-Header' => [645, OctetString, TGPP],
                       'Record-Route' => [646, OctetString, TGPP],
                       'Associated-Registered-Identities' => [647, Grouped, TGPP],
                       'Multiple-Registration-Indication' => [648, Enumerated, TGPP],
                       'Restoration-Info' => [649, Grouped, TGPP],
                       'Session-Priority' => [650, Enumerated, TGPP],
                       'Identity-with-Emergency-Registration' => [651, Grouped, TGPP],
                       'User-Identity' => [700, Grouped, TGPP],
                       'MSISDN' => [701, OctetString, TGPP],
                       'Sh-User-Data' => [702, OctetString, TGPP],
                       'Data-Reference' => [703, Enumerated, TGPP],
                       'Service-Indication' => [704, OctetString, TGPP],
                       'Subs-Req-Type' => [705, Enumerated, TGPP],
                       'Requested-Domain' => [706, Enumerated, TGPP],
                       'Current-Location' => [707, Enumerated, TGPP],
                       'Identity-Set' => [708, Enumerated, TGPP],
                       'Expiry-Time' => [709, Time, TGPP],
                       'Send-Data-Indication' => [710, Enumerated, TGPP],
                       'DSAI-Tag' => [711, OctetString, TGPP],
                       'One-Time-Notification' => [712, Enumerated, TGPP],
                       'Requested-Nodes' => [713, Unsigned32, TGPP],
                       'Serving-Node-Indication' => [714, Enumerated, TGPP],
                       'Repository-Data-ID' => [715, Grouped, TGPP],
                       'Sequence-Number' => [716, Unsigned32, TGPP],
                       'Pre-paging-Supported' => [717, Enumerated, TGPP],
                       'Local-Time-Zone-Indication' => [718, Enumerated, TGPP],
                       'UDR-Flags' => [719, Unsigned32, TGPP],
                       'TMGI' => [900, OctetString, TGPP],
                       'Required-MBMS-Bearer-Capabilities' => [901, UTF8String, TGPP],
                       'MBMS-StartStop-Indication' => [902, Enumerated, TGPP],
                       'MBMS-Service-Area' => [903, OctetString, TGPP],
                       'MBMS-Session-Duration' => [904, OctetString, TGPP],
                       'Alternative-APN' => [905, UTF8String, TGPP],
                       'MBMS-Service-Type' => [906, Enumerated, TGPP],
                       'MBMS-2G-3G-Indicator' => [907, Enumerated, TGPP],
                       'MBMS-Session-Identity' => [908, OctetString, TGPP],
                       'RAI' => [909, UTF8String, TGPP],
                       'Additional-MBMS-Trace-Info' => [910, OctetString, TGPP],
                       'MBMS-Time-To-Data-Transfer' => [911, OctetString, TGPP],
                       'MBMS-Session-Repetition-Number' => [912, OctetString, TGPP],
                       'MBMS-Required-QoS' => [913, UTF8String, TGPP],
                       'MBMS-Counting-Information' => [914, Enumerated, TGPP],
                       'MBMS-User-Data-Mode-Indication' => [915, Enumerated, TGPP],
                       'MBMS-GGSN-Address' => [916, OctetString, TGPP],
                       'MBMS-GGSN-IPv6-Address' => [917, OctetString, TGPP],
                       'MBMS-BMSC-SSM-IP-Address' => [918, OctetString, TGPP],
                       'MBMS-BMSC-SSM-IPv6-Address' => [919, OctetString, TGPP],
                       'MBMS-Flow-Identifier' => [920, OctetString, TGPP],
                       'CN-IP-Multicast-Distribution' => [921, Enumerated, TGPP],
                       'MBMS-HC-Indicator' => [922, Enumerated, TGPP],
                       'MBMS-Access-Indicator' => [923, Enumerated, TGPP],
                       'MBMS-GW-SSM-IP-Address' => [924, IPAddress, TGPP],
                       'MBMS-GW-SSM-IPv6-Address' => [925, OctetString, TGPP],
                       'MBMS-BMSC-SSM-UDP-Port' => [926, OctetString, TGPP],
                       'MBMS-GW-UDP-Port' => [927, OctetString, TGPP],
                       'MBMS-GW-UDP-Port-Indicator' => [928, Enumerated, TGPP],
                       'MBMS-Data-Transfer-Start' => [929, Unsigned64, TGPP],
                       'MBMS-Data-Transfer-Stop' => [930, Unsigned64, TGPP],
                       'Subsession-Decision-Info' => [2200, Grouped, TGPP],
                       'Subsession-Enforcement-Info' => [2201, Grouped, TGPP],
                       'Subsession-Id' => [2202, Unsigned32, TGPP],
                       'Subsession-Operation' => [2203, Enumerated, TGPP],
                       'Multiple-BBERF-Action' => [2204, Enumerated, TGPP] }
  end
end
